<?php

class Finance extends CI_controller{

    public function __construct() {
        parent::__construct();
        $this->load->library('form_validation');
        $this->load->model('User_model');
        
        }
    

    //user

    public function account()
    {
        $data = array();
        if($this->session->userdata('isUserLoggedIn'))
        {
            $data['user'] = $this->User_model->getRows(array('id'=>$this->session->userdata('userId')));
            //load the view
           
            $this->load->view('account', $data);
           
        }
        else
        {
            redirect('Finance/login');
        }
    }
    
    /*
     * User login
     */
    public function login()
    {
        $data = array();
        if($this->session->userdata('success_msg'))
        {
            $data['success_msg'] = $this->session->userdata('success_msg');
            $this->session->unset_userdata('success_msg');
        }
        if($this->session->userdata('error_msg'))
        {
            $data['error_msg'] = $this->session->userdata('error_msg');
            $this->session->unset_userdata('error_msg');
        }
        if($this->input->post('loginSubmit'))
        {
            $this->form_validation->set_rules('email', 'Email', 'required|valid_email');
            $this->form_validation->set_rules('password', 'password', 'required');
            if ($this->form_validation->run() == true) 
            {
                $con['returnType'] = 'single';
                $con['conditions'] = array(
                    'email'=>$this->input->post('email'),
                    'password' => md5($this->input->post('password'))
                   
                );
                $checkLogin = $this->User_model->getRows($con);
                if($checkLogin)
                {
                    $this->session->set_userdata('isUserLoggedIn',TRUE);
                    $this->session->set_userdata('userId',$checkLogin['id']);
                    redirect('Finance/list/');
                }
                else
                {
                    $data['error_msg'] = 'Wrong email or password, please try again.';
                }
            }
        }
        //load the view
      
        $this->load->view('login', $data);
    
    }
    
    /*
     * User registration
     */
    public function registration()
    {
        $data = array();
        $userData = array();
        if($this->input->post('regisSubmit'))
        {
            $this->form_validation->set_rules('name', 'Name', 'required');
            $this->form_validation->set_rules('email', 'Email', 'required|valid_email|callback_email_check');
            $this->form_validation->set_rules('password', 'password', 'required');
            $this->form_validation->set_rules('conf_password', 'confirm password', 'required|matches[password]');
 
            $userData = array(
                'name' => strip_tags($this->input->post('name')),
                'email' => strip_tags($this->input->post('email')),
                'password' => md5($this->input->post('password')),
                
                'phone' => strip_tags($this->input->post('phone'))
            );
 
            if($this->form_validation->run() == true)
            {
                $insert = $this->User_model->insert($userData);
                if($insert)
                {
                    $this->session->set_userdata('success_msg', 'Your registration was successfully. Please login to your account.');
                    redirect('Finance/login');
                }
                else
                {
                    $data['error_msg'] = 'Some problems occured, please try again.';
                }
            }
        }
        $data['user'] = $userData;
        //load the view
      
        $this->load->view('registration', $data);
      
    }
    
    /*
     * User logout
     */
    public function logout()
    {
        $this->session->unset_userdata('isUserLoggedIn');
        $this->session->unset_userdata('userId');
        $this->session->sess_destroy();
        redirect('Finance/login/');
    }
    
    /*
     * Existing email check during validation
     */
    public function email_check($str)
    {
        $con['returnType'] = 'count';
        $con['conditions'] = array('email'=>$str);
        $checkEmail = $this->User_model->getRows($con);
        if($checkEmail > 0)
        {
            $this->form_validation->set_message('email_check', 'The given email already exists.');
            return FALSE;
        } 
        else 
        {
            return TRUE;
        }
    }







    //
        public function show() {
        $data['show_table'] = $this->view_table();
        $this->load->view('show', $data);
        }
        public function date() {
            $data['show_table'] = $this->view_table();
            $this->load->view('date', $data);
            }
        public function view_table(){
        $result = $this->User_model->show_all_data();
        if ($result != false) {
        return $result;
        } else {
        return 'Database is empty !';
        }
        }
        
        
    //report
    function report()
    {
        $this->load->model('User_model');
        $data = array();
        if($this->session->userdata('isUserLoggedIn'))
        {
        $session_data = $this->session->userdata('userId');
        $id = $this->session->userdata('userId');
        // profile
        $data['users'] = $this->User_model->get_user_data3($id);
        $data['spouse'] = $this->User_model->get_user_spouse($id);
        $data['children'] = $this->User_model->get_user_children($id);
        $data['parent'] = $this->User_model->get_user_parent($id);
        // income
        $data['income'] = $this->User_model->get_user_income_goal($id);
        // goals
        $data['edu'] = $this->User_model->get_user_education($id);
        $data['goal'] = $this->User_model->get_user_car_goal($id);
        $data['health'] = $this->User_model->get_user_health_goal($id);
        $data['retirement'] = $this->User_model->get_user_retire_goal($id);
        $data['marriage'] = $this->User_model->get_user_marrriage_goal($id);
        $data['protection'] = $this->User_model->get_user_protection_goal($id);
        // assets
        $data['networth'] = $this->User_model->get_user_networth($id);
        $data['growth'] = $this->User_model->get_user_growth($id);
        $data['insurance'] = $this->User_model->get_user_insurance($id);
        // expenses
        $data['house'] = $this->User_model->get_user_house($id);
        $data['style'] = $this->User_model->get_user_style($id);
        $data['investments'] = $this->User_model->get_user_investments($id);
        $data['emis'] = $this->User_model->get_user_emis($id);
        // 
        $data['user'] = $this->User_model->getRows(array('id'=>$this->session->userdata('userId')));
        $this->load->view('report', $data);   
        }
        else
        {
            redirect('Finance/login');
        }
    }

    

  

    function list()
    {
        $this->load->model('User_model');
        $data = array();
        if($this->session->userdata('isUserLoggedIn'))
        {
        $session_data = $this->session->userdata('userId');
        $id = $this->session->userdata('userId');
        $data['users'] = $this->User_model->get_user_data3($id);
        $data['spouse'] = $this->User_model->get_user_spouse($id);
        $data['children'] = $this->User_model->get_user_children($id);
        $data['parent'] = $this->User_model->get_user_parent($id);
        $data['user'] = $this->User_model->getRows(array('id'=>$this->session->userdata('userId')));
        $this->load->view('list', $data);   
        }
        else
        {
            redirect('Finance/login');
        }
    }



   
    function riskcreate()
    {
                
        // the "TRUE" argument tells it to return the content, rather than display it immediately
       
       
        $this->load->model('User_model');
      
        $this->form_validation->set_rules('riskprofile', 'Risk tolerance', 'required');
        $this->form_validation->set_rules('volcapacity', 'Volatility capacity', 'required');

        $this->form_validation->set_rules('invhorizon', 'Investment time horizon', 'required');
        $this->form_validation->set_rules('expreturn', 'Expected rate of return', 'required');

        $this->form_validation->set_rules('invexp', 'Invstment experience','required');
    
        
        if ($this->form_validation->run() ==  false){
            

            $this->load->view('riskcreate');
        } else {

            $formArray = array();

           

            $formArray['riskprofile'] = $this->input->post('riskprofile');
            $formArray['volcapacity'] = $this->input->post('volcapacity');
            $formArray['invhorizon'] = $this->input->post('invhorizon');

            $formArray['expreturn'] = $this->input->post('expreturn');
           
            $formArray['invexp'] = $this->input->post('invexp');
            
            $this->User_model->riskcreate( $formArray);
            $this->session->set_flashdata('success','Record added Successfullly');
            redirect(base_url().'index.php/Finance/list');
           
        
    }
        
    }
   


    function create()
    {
        $this->load->model('User_model');
      
        $this->form_validation->set_rules('yourname', 'Name', 'required');
        $this->form_validation->set_rules('bdate', 'Birth Date', 'required');

        $this->form_validation->set_rules('mstatus', 'Marital Status', 'required');
        $this->form_validation->set_rules('address', 'Address', 'required');

        $this->form_validation->set_rules('mobile', 'Mobile No.','required|regex_match[/^[0-9]{10}$/]');
        $this->form_validation->set_rules('add_mob', 'Mobile No.','regex_match[/^[0-9]{10}$/]');

        $this->form_validation->set_rules('email', 'email', 'required');


     
        $this->form_validation->set_rules('occupation', 'occupation', 'required');

        $this->form_validation->set_rules('income', 'income', 'required');
      
        if ($this->form_validation->run() ==  false){
            if($this->session->userdata('isUserLoggedIn'))
                    {
                        $data['user'] = $this->User_model->getRows(array('id'=>$this->session->userdata('userId')));
                        //load the view
                      

                        $this->load->view('create',$data);
                    
                    }
            else
            {
                redirect('Finance/login');
            }
               
        } else {

            $formArray = array();

           

            $formArray['yourname'] = $this->input->post('yourname');
            $formArray['bdate'] = $this->input->post('bdate');
            $formArray['mstatus'] = $this->input->post('mstatus');

            $formArray['address'] = $this->input->post('address');
           
            $formArray['mobile'] = $this->input->post('mobile');

            $formArray['add_mob'] = $this->input->post('add_mob');
            $formArray['email'] = $this->input->post('email');

            $formArray['occupation'] = $this->input->post('occupation');
            $formArray['income'] = $this->input->post('income');
            
            $formArray['created_date'] = date('Y-m-d');
            $formArray['age'] = (($formArray['created_date']) - date('Y',strtotime($formArray['bdate'])));
           
        
            $formArray['profile_id'] = $this->input->post('profile_id');
            $this->User_model->create( $formArray);

           

            $this->session->set_flashdata('success','Your profile added Successfullly');
            redirect(base_url().'index.php/Finance/list');
           
        
    }
        
    }
    function edit($userId)
    {
        $this->load->model('User_model');
       

       

            $formArray = array();
            $formArray['yourname'] = $this->input->post('yourname');
            $formArray['bdate'] = $this->input->post('bdate');
            $formArray['mstatus'] = $this->input->post('mstatus');

            $formArray['address'] = $this->input->post('address');
           
            $formArray['mobile'] = $this->input->post('mobile');

            $formArray['add_mob'] = $this->input->post('add_mob');
            $formArray['email'] = $this->input->post('email');

            $formArray['occupation'] = $this->input->post('occupation');
            $formArray['income'] = $this->input->post('income');
            
            $formArray['created_date'] = date('Y-m-d');
            $formArray['age'] = (($formArray['created_date']) - date('Y',strtotime($formArray['bdate'])));
           
        
            $formArray['profile_id'] = $this->input->post('profile_id');
   

            $this->User_model->updateUser($userId,$formArray);
            $this->session->set_flashdata('success','Your profile updated Successfullly');
            redirect(base_url().'index.php/Finance/list');
        

        
    }

 
    function spouse()
    {

        $this->form_validation->set_rules('spouse_name', 'Naspouse_nameme', 'required');
        $this->form_validation->set_rules('DOB', 'DOB', 'required');

        
            $formArray = array();
            $formArray['spouse_name'] = $this->input->post('spouse_name');
            $formArray['DOB'] = $this->input->post('DOB');
          
            $formArray['user_id'] = $this->input->post('user_id');
            $formArray['created_date'] = date('Y-m-d');
            $formArray['age'] = (($formArray['created_date']) - date('Y',strtotime($formArray['DOB'])));
            $this->User_model->create_spouse( $formArray);
  
            $this->session->set_flashdata('success','Spouse added Successfullly');
            redirect(base_url().'index.php/Finance/list');
          
    }


    
    function children()
    {

        $this->form_validation->set_rules('children_name', 'children_name', 'required');
        $this->form_validation->set_rules('children_DOB', 'children_DOB', 'required');
        $this->form_validation->set_rules('gender', 'gender', 'required');

        if ($this->form_validation->run() ==  false){
            $this->load->view('list');
       }
       else{
            $formArray = array();
            $formArray['children_name'] = $this->input->post('children_name');
            $formArray['children_DOB'] = $this->input->post('children_DOB');
            $formArray['gender'] = $this->input->post('gender');
            $formArray['created_date'] = date('Y-m-d');
            $formArray['age'] = (($formArray['created_date']) - date('Y',strtotime($formArray['children_DOB'])));
            $formArray['user_id'] = $this->input->post('user_id');
            $this->User_model->create_children( $formArray);
  
            $this->session->set_flashdata('success','Children added Successfullly');
            redirect(base_url().'index.php/Finance/list');
       }
        
    
        
    }

    function parent()
    {

        $this->form_validation->set_rules('parent_name', 'parent_name', 'required');
        $this->form_validation->set_rules('parent_date', 'parent_date', 'required');
        $this->form_validation->set_rules('relationship', 'relationship', 'required');

        if ($this->form_validation->run() ==  false){
            $this->load->view('list');
       }
       else{
            $formArray = array();
            $formArray['parent_name'] = $this->input->post('parent_name');
            $formArray['parent_date'] = $this->input->post('parent_date');
            $formArray['relationship'] = $this->input->post('relationship');
            $formArray['created_date'] = date('Y-m-d');
            $formArray['age'] = (($formArray['created_date']) - date('Y',strtotime($formArray['parent_date'])));

            $formArray['user_id'] = $this->input->post('user_id');
            $this->User_model->create_parent( $formArray);
  
            $this->session->set_flashdata('success','Parent added Successfullly');
            redirect(base_url().'index.php/Finance/list');
       }
        
    
        
    }

    //iincome data
    function risk()
    {
        $this->load->model('User_model');    
        $data = array();    
        if($this->session->userdata('isUserLoggedIn'))
        {
        $session_data = $this->session->userdata('userId');
        $id = $this->session->userdata('userId');
        
        $data['risk'] = $this->User_model->get_user_risk($id);
        $data['user'] = $this->User_model->getRows(array('id'=>$this->session->userdata('userId')));
        
        $this->load->view('risks', $data);   
        }
        else
        {
            redirect('Finance/login');
        }
       
    }


    //goals

    function goal()
    {
        $this->load->model('User_model');    
        $data = array();    
        if($this->session->userdata('isUserLoggedIn'))
        {
        $session_data = $this->session->userdata('userId');
        $id = $this->session->userdata('userId');
        $data['child_name'] = $this->User_model->get_children_from_reg($id);
        $data['sp_name'] = $this->User_model->get_spouse_from_reg($id);


        $data['users'] = $this->User_model->get_user_education($id);
        $data['goal'] = $this->User_model->get_user_car_goal($id);
        $data['health'] = $this->User_model->get_user_health_goal($id);
        $data['retirement'] = $this->User_model->get_user_retire_goal($id);
        $data['marriage'] = $this->User_model->get_user_marrriage_goal($id);
        $data['protection'] = $this->User_model->get_user_protection_goal($id);


        $data['user'] = $this->User_model->getRows(array('id'=>$this->session->userdata('userId')));
        
        $this->load->view('goal', $data);   
        }
        else
        {
            redirect('Finance/login');
        }
       
    }
//    eduaction

function education()
    {

            $this->form_validation->set_rules('childname', 'childname', 'required');
            $this->form_validation->set_rules('annual_cost', 'annual_cost', 'required');
            $this->form_validation->set_rules('course_duration', 'course_duration', 'required');
            $this->form_validation->set_rules('child_age', 'child_age', 'required');
            $this->form_validation->set_rules('years_start_education', 'years_start_education', 'required');
            $this->form_validation->set_rules('profession', 'profession', 'required');

            // $this->form_validation->set_rules('accomodation_cost', 'accomodation_cost', 'required');
            $this->form_validation->set_rules('yearly_expenses', 'yearly_expenses', 'required');
            $this->form_validation->set_rules('edu_existing_fund', 'edu_existing_fund', 'required');

            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
                $this->session->set_flashdata('failure','Sorry, Education plan  not added');
                redirect(base_url().'index.php/Finance/goal/' .$id);        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['childname'] = $this->input->post('childname');
                $formArray['annual_cost'] = $this->input->post('annual_cost');
                $formArray['course_duration'] = $this->input->post('course_duration');

                $formArray['child_age'] = $this->input->post('child_age');
                $formArray['years_start_education'] = $this->input->post('years_start_education');
                $formArray['profession'] = $this->input->post('profession');

                // $formArray['accomodation_cost'] = $this->input->post('accomodation_cost');
                $formArray['yearly_expenses'] = $this->input->post('yearly_expenses');
                $formArray['edu_existing_fund'] = $this->input->post('edu_existing_fund');    
            
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_education( $formArray);
    
                $this->session->set_flashdata('success','Eduacation detail added Successfullly');
                redirect(base_url().'index.php/Finance/goal/' .$id);
        }    
    }


    function car()
    {

            $this->form_validation->set_rules('goal_name', 'goal_name', 'required');
            $this->form_validation->set_rules('amount', 'amount', 'required');
            $this->form_validation->set_rules('years_req', 'years_req', 'required');
            $this->form_validation->set_rules('existing_fund', 'existing_fund', 'required');
           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
            $this->session->set_flashdata('failure','Sorry, goal  not added');
            redirect(base_url().'index.php/Finance/goal/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['goal_name'] = $this->input->post('goal_name');
                $formArray['amount'] = $this->input->post('amount');
                $formArray['years_req'] = $this->input->post('years_req');

                $formArray['existing_fund'] = $this->input->post('existing_fund');
               
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_goal_car( $formArray);
    
                $this->session->set_flashdata('success','Goal added Successfullly');
                redirect(base_url().'index.php/Finance/goal/' .$id);
        }    
    }

    // health
    function health()
    {

            $this->form_validation->set_rules('health_name', 'health_name', 'required');
            $this->form_validation->set_rules('income_needed', 'income_needed', 'required');
            $this->form_validation->set_rules('medical_emergency', 'medical_emergency', 'required');
            $this->form_validation->set_rules('Income_without_efforts', 'Income_without_efforts', 'required');
            $this->form_validation->set_rules('goal_add_fund', 'goal_add_fund', 'required');
           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
            $this->session->set_flashdata('failure','Sorry, Health plan not added');
            redirect(base_url().'index.php/Finance/goal/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['health_name'] = $this->input->post('health_name');
                $formArray['income_needed'] = $this->input->post('income_needed');
                $formArray['medical_emergency'] = $this->input->post('medical_emergency');
                $formArray['Income_without_efforts'] = $this->input->post('Income_without_efforts');

                $formArray['goal_add_fund'] = $this->input->post('goal_add_fund');
               
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_goal_health( $formArray);
    
                $this->session->set_flashdata('success','health plan added Successfullly');
                redirect(base_url().'index.php/Finance/goal/' .$id);
        }    
    }

    function retire()
    {

            $this->form_validation->set_rules('retirement_type', 'retirement_type', 'required');
            $this->form_validation->set_rules('current_age', 'current_age', 'required');
            $this->form_validation->set_rules('Retirement_age', 'Retirement_age', 'required');
            $this->form_validation->set_rules('Life_Expectancy_Age', 'Life_Expectancy_Age', 'required');
            $this->form_validation->set_rules('Monthly_pension_at_retirement', 'Monthly_pension_at_retirement', 'required');
            $this->form_validation->set_rules('income_after_after', 'income_after_after', 'required');
            $this->form_validation->set_rules('other_fund', 'other_fund', 'required');
           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
            $this->session->set_flashdata('failure','Sorry, Retirement planning not added');
            redirect(base_url().'index.php/Finance/goal/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['retirement_type'] = $this->input->post('retirement_type');
                $formArray['current_age'] = $this->input->post('current_age');
                $formArray['Retirement_age'] = $this->input->post('Retirement_age');
                $formArray['Life_Expectancy_Age'] = $this->input->post('Life_Expectancy_Age');
                $formArray['Monthly_pension_at_retirement'] = $this->input->post('Monthly_pension_at_retirement');
                $formArray['income_after_after'] = $this->input->post('income_after_after');
                $formArray['other_fund'] = $this->input->post('other_fund');

                
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_goal_retire( $formArray);
    
                $this->session->set_flashdata('success','Retirement plan added Successfullly');
                redirect(base_url().'index.php/Finance/goal/' .$id);
        }    
    }
// marriage
    function marriage()
    {

            $this->form_validation->set_rules('name', 'name', 'required');
            $this->form_validation->set_rules('years_left', 'years_left', 'required');
            $this->form_validation->set_rules('other_expense', 'other_expense', 'required');
            $this->form_validation->set_rules('existing_fund', 'existing_fund', 'required');
           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
            $this->session->set_flashdata('failure','Sorry, Marriage  data not added');
            redirect(base_url().'index.php/Finance/goal/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['name'] = $this->input->post('name');
                $formArray['years_left'] = $this->input->post('years_left');
                $formArray['other_expense'] = $this->input->post('other_expense');
                $formArray['existing_fund'] = $this->input->post('existing_fund');
               
                
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_goal_marriage( $formArray);
    
                $this->session->set_flashdata('success','marriage data added Successfullly');
                redirect(base_url().'index.php/Finance/goal/' .$id);
        }    
    }
    function protection()
    {

            $this->form_validation->set_rules('name', 'name', 'required');
            $this->form_validation->set_rules('approx_amount', 'approx_amount', 'required');
           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
            $this->session->set_flashdata('failure','Sorry, Family protection not added');
            redirect(base_url().'index.php/Finance/goal/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['name'] = $this->input->post('name');
                $formArray['approx_amount'] = $this->input->post('approx_amount');
               
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_goal_protection( $formArray);
    
                $this->session->set_flashdata('success','family pritection added Successfullly');
                redirect(base_url().'index.php/Finance/goal/' .$id);
        }    
    }

    //income
    function income()
    {
         $this->load->model('User_model');    
        $data = array();    
        if($this->session->userdata('isUserLoggedIn'))
        {
        $session_data = $this->session->userdata('userId');
        $id = $this->session->userdata('userId');  
        $data['income'] = $this->User_model->get_user_income_goal($id);
        $data['user'] = $this->User_model->getRows(array('id'=>$this->session->userdata('userId')));     
        $this->load->view('income', $data);   
        }
        else
        {
            redirect('Finance/login');
        }
       
    }


    function income_add()
    {

            $this->form_validation->set_rules('name', 'name', 'required');
            $this->form_validation->set_rules('salary', 'salary', 'required');
            $this->form_validation->set_rules('bonus', 'bonus', 'required');
            $this->form_validation->set_rules('business', 'business', 'required');
            $this->form_validation->set_rules('property', 'property', 'required');
            $this->form_validation->set_rules('interest', 'interest', 'required');
            $this->form_validation->set_rules('other_income', 'other_income', 'required');
          
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
                $this->session->set_flashdata('failure','Sorry, income not added');
                redirect(base_url().'index.php/Finance/income/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['name'] = $this->input->post('name');
                $formArray['salary'] = $this->input->post('salary');
                $formArray['bonus'] = $this->input->post('bonus');
                $formArray['business'] = $this->input->post('business');
                $formArray['property'] = $this->input->post('property');
                $formArray['interest'] = $this->input->post('interest');
                $formArray['other_income'] = $this->input->post('other_income');
             
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_goal_income( $formArray);
    
                $this->session->set_flashdata('success','family pritection added Successfullly');
                redirect(base_url().'index.php/Finance/income/' .$id);
        }    
    }
//    edit income
function edit_income($userId)
{
    $this->load->model('User_model');
        $session_data = $this->session->userdata('userId');
        $id = $this->session->userdata('userId');
        $formArray = array();
        $formArray['name'] = $this->input->post('name');
        $formArray['salary'] = $this->input->post('salary');
        $formArray['bonus'] = $this->input->post('bonus');

        $formArray['business'] = $this->input->post('business');
       
        $formArray['property'] = $this->input->post('property');

        $formArray['interest'] = $this->input->post('interest');
        $formArray['other_income'] = $this->input->post('other_income');

      
        $formArray['user_id'] = $this->input->post('user_id');


        $this->User_model->updateIncome($userId,$formArray);
        $this->session->set_flashdata('success','Your profile updated Successfullly');
        redirect(base_url().'index.php/Finance/income/' .$id);
    

    
}

function expense()
{
    $this->load->model('User_model');
    $data = array();
    if($this->session->userdata('isUserLoggedIn'))
    {
    $session_data = $this->session->userdata('userId');
    $id = $this->session->userdata('userId');
    $data['house'] = $this->User_model->get_user_house($id);
    $data['style'] = $this->User_model->get_user_style($id);
    $data['investments'] = $this->User_model->get_user_investments($id);
    $data['emis'] = $this->User_model->get_user_emis($id);
    $data['user'] = $this->User_model->getRows(array('id'=>$this->session->userdata('userId')));
    $this->load->view('expense', $data);   
    }
    else
    {
        redirect('Finance/login');
    }
}

function house()
    {

            $this->form_validation->set_rules('electricity_charges', 'electricity_charges', 'required');
            $this->form_validation->set_rules('gas', 'gas', 'required');
            $this->form_validation->set_rules('mobile_or_internet', 'mobile_or_internet', 'required');
            $this->form_validation->set_rules('child_care', 'child_care', 'required');
            $this->form_validation->set_rules('fees', 'fees', 'required');
            $this->form_validation->set_rules('travelling', 'travelling', 'required');
           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
            $this->session->set_flashdata('failure','Sorry, Basic household not added');
                redirect(base_url().'index.php/Finance/expense/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['electricity_charges'] = $this->input->post('electricity_charges');
                $formArray['gas'] = $this->input->post('gas');
                $formArray['mobile_or_internet'] = $this->input->post('mobile_or_internet');
                $formArray['child_care'] = $this->input->post('child_care');
                $formArray['fees'] = $this->input->post('fees');
                $formArray['travelling'] = $this->input->post('travelling');
               
                
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_expense_house( $formArray);
    
                $this->session->set_flashdata('success','Basic HouseHold expenses added Successfullly');
                redirect(base_url().'index.php/Finance/expense/' .$id);
        }    
    }

    function style()
    {

            $this->form_validation->set_rules('loan', 'loan', 'required');
            $this->form_validation->set_rules('clothing', 'clothing', 'required');
            $this->form_validation->set_rules('pet_care', 'pet_care', 'required');
            $this->form_validation->set_rules('entertainment', 'entertainment', 'required');
            $this->form_validation->set_rules('personal_care', 'personal_care', 'required');
            $this->form_validation->set_rules('donations', 'donations', 'required');
           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
                $this->session->set_flashdata('failure','Sorry, Basic life style expenses not added');
                redirect(base_url().'index.php/Finance/expense/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['loan'] = $this->input->post('loan');
                $formArray['clothing'] = $this->input->post('clothing');
                $formArray['pet_care'] = $this->input->post('pet_care');
                $formArray['entertainment'] = $this->input->post('entertainment');
                $formArray['personal_care'] = $this->input->post('personal_care');
                $formArray['donations'] = $this->input->post('donations');
               
                
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_expense_style( $formArray);
    
                $this->session->set_flashdata('success','Basic HouseHold expenses added Successfullly');
                redirect(base_url().'index.php/Finance/expense/' .$id);
        }    
    }

    function invest()
    {

            $this->form_validation->set_rules('life_insurance_premium', 'life_insurance_premium', 'required');
            $this->form_validation->set_rules('mutual_fund', 'mutual_fund', 'required');
            $this->form_validation->set_rules('gold', 'gold', 'required');
            $this->form_validation->set_rules('other_investments', 'other_investments', 'required');
           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
                $this->session->set_flashdata('failure','Sorry, Investment expenses not added');
                redirect(base_url().'index.php/Finance/expense/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['life_insurance_premium'] = $this->input->post('life_insurance_premium');
                $formArray['mutual_fund'] = $this->input->post('mutual_fund');
                $formArray['gold'] = $this->input->post('gold');
                $formArray['other_investments'] = $this->input->post('other_investments');
             
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_expense_invest( $formArray);
    
                $this->session->set_flashdata('success','Investments expenses added Successfullly');
                redirect(base_url().'index.php/Finance/expense/' .$id);
        }    
}

function emis()
    {

            $this->form_validation->set_rules('home_emi', 'home_emi', 'required');
            $this->form_validation->set_rules('car_emi', 'car_emi', 'required');
            $this->form_validation->set_rules('consumer_emi', 'consumer_emi', 'required');
            $this->form_validation->set_rules('personal_emi', 'personal_emi', 'required');
            $this->form_validation->set_rules('other_emi', 'other_emi', 'required');

           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
                $this->session->set_flashdata('failure','Sorry, EMIs expenses not added');
                redirect(base_url().'index.php/Finance/expense/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['home_emi'] = $this->input->post('home_emi');
                $formArray['car_emi'] = $this->input->post('car_emi');
                $formArray['consumer_emi'] = $this->input->post('consumer_emi');
                $formArray['personal_emi'] = $this->input->post('personal_emi');
                $formArray['other_emi'] = $this->input->post('other_emi');
             
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_expense_emis( $formArray);
    
                $this->session->set_flashdata('success','EMIs added Successfullly');
                redirect(base_url().'index.php/Finance/expense/' .$id);
        }    
}

// assets


function assets()
{
    $this->load->model('User_model');
    $data = array();
    if($this->session->userdata('isUserLoggedIn'))
    {
    $session_data = $this->session->userdata('userId');
    $id = $this->session->userdata('userId');
    $data['child_name'] = $this->User_model->get_children_from_reg($id);

    $data['networth'] = $this->User_model->get_user_networth($id);
    $data['growth'] = $this->User_model->get_user_growth($id);
    $data['insurance'] = $this->User_model->get_user_insurance($id);
    $data['user'] = $this->User_model->getRows(array('id'=>$this->session->userdata('userId')));
    $this->load->view('assets', $data);   
    }
    else
    {
        redirect('Finance/login');
    }
}


function dashboard()
{
     $this->load->model('User_model');    
    $data = array();    
    if($this->session->userdata('isUserLoggedIn'))
    {
    $session_data = $this->session->userdata('userId');
    $id = $this->session->userdata('userId');
   
    $data['common_rate'] = $this->User_model->get_user_rate($id);
    // $data['monthly_income'] = $this->User_model->income_monthly($id);
  

    $data['user'] = $this->User_model->getRows(array('id'=>$this->session->userdata('userId')));
    
    $this->load->view('dashboard', $data);   
    }
    else
    {
        redirect('Finance/login');
    }
   
}

function networth()
    {

            $this->form_validation->set_rules('assets1', 'assets1', 'required');
            $this->form_validation->set_rules('assets2', 'assets2', 'required');
            $this->form_validation->set_rules('assets3', 'assets3', 'required');
          
           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
                $this->session->set_flashdata('failure','Sorry, Networth plan  not added');
                redirect(base_url().'index.php/Finance/assets/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['assets1'] = $this->input->post('assets1');
                $formArray['assets2'] = $this->input->post('assets2');
                $formArray['assets3'] = $this->input->post('assets3');
               
                
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_expense_networth( $formArray);
    
                $this->session->set_flashdata('success','Networth plan added Successfullly');
                redirect(base_url().'index.php/Finance/assets/' .$id);
        }    
    }

    function growth()
    {

           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['name'] = $this->input->post('name');
                $formArray['age'] = $this->input->post('age');
                $formArray['income'] = $this->input->post('income');
                $formArray['family_expenses'] = $this->input->post('family_expenses');
                $formArray['personal_expenses'] = $this->input->post('personal_expenses');

             
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_expense_growth( $formArray);
    
                $this->session->set_flashdata('success','Income growth added Successfullly');
                redirect(base_url().'index.php/Finance/assets/' .$id);
     
}

function insurance()
    {

            $this->form_validation->set_rules('name', 'name', 'required');
            $this->form_validation->set_rules('age', 'age', 'required');
            $this->form_validation->set_rules('retirement_age', 'retirement_age', 'required');
            $this->form_validation->set_rules('yearly_income', 'yearly_income', 'required');
            $this->form_validation->set_rules('personal_expense', 'personal_expense', 'required');
            $this->form_validation->set_rules('expected_growth', 'expected_growth', 'required');

           
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
            if ($this->form_validation->run() ==  false){
                $this->session->set_flashdata('failure','Sorry, Insurance not added');
                redirect(base_url().'index.php/Finance/assets/' .$id);
        }
        else{
            $session_data = $this->session->userdata('userId');
            $id = $this->session->userdata('userId');
                $formArray = array();
                $formArray['name'] = $this->input->post('name');
                $formArray['age'] = $this->input->post('age');
                $formArray['retirement_age'] = $this->input->post('retirement_age');
                $formArray['yearly_income'] = $this->input->post('yearly_income');
                $formArray['personal_expense'] = $this->input->post('personal_expense');
                $formArray['expected_growth'] = $this->input->post('expected_growth');
             
                $formArray['user_id'] = $this->input->post('user_id');
                $this->User_model->create_expense_insurance( $formArray);
    
                $this->session->set_flashdata('success','Insurance added Successfullly');
                redirect(base_url().'index.php/Finance/assets/' .$id);
        }    
}

// assets

//delete spouse
    function delete($userId)
    {
        $this->load->model('User_model');
        $user = $this->User_model->getSp($userId);

        if(empty($user)){
            $this->session->set_flashdata('failure','Record not found in database');
            redirect(base_url().'index.php/Finance/list');

        }
        $this->User_model->deletespouse($userId,$formArray);  
        $this->session->set_flashdata('success','spouse deleted successfully');
            redirect(base_url().'index.php/Finance/list');
    }


    //delete children
    function delete_children($userId)
    {
        $this->load->model('User_model');
        $user = $this->User_model->getCh($userId);

        if(empty($user)){
            $this->session->set_flashdata('failure','Record not found in database');
            redirect(base_url().'index.php/Finance/list');

        }
        $this->User_model->deleteChildren($userId,$formArray);  
        $this->session->set_flashdata('success','children deleted successfully');
            redirect(base_url().'index.php/Finance/list');
    }

    //delete parent
    function delete_parent($userId)
    {
        $this->load->model('User_model');
        $user = $this->User_model->getParen($userId);

        if(empty($user)){
            $this->session->set_flashdata('failure','Record not found in database');
            redirect(base_url().'index.php/Finance/list');

        }
        $this->User_model->deleteParent($userId,$formArray);  
        $this->session->set_flashdata('success','parent deleted successfully');
            redirect(base_url().'index.php/Finance/list');
    }
    
} 
?>